//+------------------------------------------------------------------+
//|                                             MA Martingale v3.mq4 |
//|                                                    Ramiro Alonso |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Ramiro Alonso - Version 1.1"
#property link      "www.forexfactory.com/forum"

#include <stdlib.mqh>
#include <stderror.mqh> //Handles errors.
#include <info.mq4> //Handles information displayed on chart.

#include <AllOrdersControl.mq4> //Place in memory the array containing orders ejecuted by EA.
                              //It makes faster and secure ejecution of this EA.
                              
static int prevtime = 0;//                                 
extern int Magic = 9999;//Number used by EA to identify orders placed by itself and manage them.

extern int TakeProfit=30; //Fixed pips profit target on each order.
extern int PipsStep=25; //Fixed pip loss until a new order is entered in the same way.

extern int MaxTrades = 9; //Max number of orders in a martingale (group of related orders).

extern string EmergencyClose_desc="Order number to close martingale at break even";
extern int EmergencyClose = 9; //Order number to close martingale at break even.
extern bool CloseOnEmergency = false; //Close martingale before open EmergencyClose order number.

extern double SecureProfit=0.1; //Profit/Loss target as % on balance.

extern bool TrailingProfit=false;

extern double FactorLot = 2; //Multiplier of previous lotsize. This is the lot size growth factor of the next order.
extern double FactorPips = 1;//Multiplier of previos PipsStep. This is the pip loss growth factor of the next order.
extern int OrdenSalto = 5;//Number of order to make a jump (Salto) on the FactorLot. It could be negative also (fall).
extern double Salto = 1;//Determine size jump on growth of the lot size.


extern bool mm=true; //If it is "true" EA manage money management as percentage of balance.
extern bool MiniAccount=true; //If EA work on a mini or standar.

extern string ReversCondition_desc="Read inverse the indicator signals. If buy, then sell and viceversa";
extern bool ReverseCondition=false; //Read inverse the indicator signals. If buy, then sell and viceversa.

extern bool TradeMACD = true;
extern bool TradeSTOCH = true;

extern double risk=0.15; //Lot size of initial trade as percentage of balance
extern double InitialFixedLots=0.01; //Minimum lot size admitted by broker/trader.
extern double MaxLots=50;//Maximum lot size admitted by broker/trader.

extern int MACDFast = 12; 
extern int MACDSlow = 26;
extern int MACDPeriod = 12;
extern string MAPrice_desc="0-Close/ 1-Open/ 2-High/ 3-Low/ 4-8 Others";
extern int MACDPrice = MODE_OPEN;

extern int KPeriod = 8;
extern int DPeriod = 7;
extern int Slowing = 21;
extern int Method =MODE_SMMA;
extern int Price =PRICE_CLOSE;


extern string StopTrading_desc="Stops trading when all opened orders get closed";
extern bool StopTrading = false; //Stops trading if there isn't open orders.

extern int slippage = 40;//Slippage for close orders.

extern string ForceOrderType_desc="Force open trade. 0-Buy/ 1-Sell /6-None";
extern int ForceOrderType = 6;

extern string UpdateVar_Desc="Trader sets values when EA lose them by restart";
extern bool UpdateVar = false; //Force variables values update.
extern double NewLastLotSize = 0; //Variable lost
extern int NewMaxTradesAux = 0; //Variable lost
extern int NewPreviousOpenOrders = 0; //variable lost
extern int NewMyOrderType=6; //variable lost

int cnt, cnt2, NumberOfTries = 25, error, leverage=0;
double lotsi=0, myLotAux, tp, sl, EnterPrice, SaltoAux;
double PipsStepAux, ProfitTarget;
string text = "";
bool ContinueOpening=true;



//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
//int start()
//  {
  //if(Time[0] == prevtime) return(0);//   
  // prevtime = Time[0];//   ,  

int init()
  {
//----
   info_init(false);
   
   if(StopTrading==false || IsTradeAllowed() || IsExpertEnabled())
   {
     info( 0, "MA Martingale v3.0 is allowed to trade.", White );
	  info( 1, "On first tick this message will desapear", White );
	}
	else
	{
	   info( 0, "Allow EA trading by setting StopTrading = false", Red );
	   info( 1, "Press F7 and mark case Allow Live Trading on Common page", Red );
	}
   
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
   info_clear();
   info_deinit();
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
if(Time[0] == prevtime) return(0);//   
   prevtime = Time[0];//   ,  


   //Static variables are stored in permanent memory for later retrieve 
   //on reloaded of EA (i.e. after a shut down of computer).
   static double LastLotSize = 0;
   static int MaxTradesAux = 0;
   static int PreviousOpenOrders = 0;
   static int myOrderType=6;
   
   //Identifica las ordenes abiertas por el EA y las carga en una matriz para manejarlas
   //mas rpido y unvoco.
   AllOrdersInit(Magic);
   
   //Esta condicion es necesaria para resetear el valor de PreviousOpenOrders cuando se cierra
   //todo, y no antes de cerrar todo.
   if(_ExpertOrdersTotal<1)
   {
      if(StopTrading==true)
      {
         info_clear();
         Comment("EA BLOQUEADO POR EL USUARIO.");
         return;
      }
      else
      {
          Comment("");
          LastLotSize = 0;
          MaxTradesAux = 0;
          PreviousOpenOrders = _ExpertOrdersTotal;
          myOrderType=6;
          
      }
   }
   
    if(UpdateVar==true)
   {
      LastLotSize = NewLastLotSize;
      MaxTradesAux = NewMaxTradesAux;
      PreviousOpenOrders = NewPreviousOpenOrders;
      myOrderType = NewMyOrderType;
   }

   
   //Si una orden toc su TP, entonces cierra las dems de la serie.
   if (PreviousOpenOrders>_ExpertOrdersTotal) 
   {	
      //Aseguro que no ingrese nuevas ordenes.
      ContinueOpening=False;
      //Busca asegurarse que se hayan cerrado todas las ordenes. En fowartest ocurri que una
      //orden intermedia qued sin cerrar por un problema momentneo de conexin.
      //De esta manera el EA cierra todo y luego revisa si efectivamente cerr todo.  
      CierraTodo();
      MaxTradesAux = 0;
      //Este return es necesario para que no reasigne el valor de PreviousOpenOrders cuando no
      //se cerraron juntas todas las ordenes de una misma martingala.
      return;
   }
   
   //Evalua si se abrieron el maximo de ordenes admitidas, y permite o no abrir nuevas si
   //fuera necesario.
   PreviousOpenOrders=_ExpertOrdersTotal;
   if (_ExpertOrdersTotal>=(MaxTrades+MaxTradesAux)) 
   {
	  ContinueOpening=False;
   } else {
	  ContinueOpening=True;
   }
   
   //Cierra todo si la martingala alcanza un valor mayor o igual a cero a partir de EmergencyClose.
//   if((_ExpertProfitTotal)>=0 &&
//   _ExpertOrdersTotal>=(EmergencyClose+MaxTradesAux))
//   {
//   CierraTodo();
//   MaxTradesAux = 0;
//   }
   
   //If martingale has reached SecureProfit amount close all or place a stop loss.
   ProfitTarget = NormalizeDouble(AccountBalance()*SecureProfit/100,2);
   
   //Cierra todo si la martingala alcanza un valor mayor o igual a cero a partir de EmergencyClose.
   //Or close all if martingale has reached profit target (not take profit price).
   if(_ExpertProfitTotal>=0 && ProfitTarget > 0)
   {  
      if(_ExpertOrdersTotal>=(EmergencyClose+MaxTradesAux) || _ExpertProfitTotal>=ProfitTarget)
      {
         CierraTodo();
         ContinueOpening=False;
         myOrderType = 6;
         MaxTradesAux = 0;
      }
      
   }
   
   if(_ExpertProfitTotal<0 && ProfitTarget<0)
   {
      if(_ExpertProfitTotal<=ProfitTarget)
      {
         CierraTodo();
         ContinueOpening=False;
         myOrderType = 6;
         MaxTradesAux = 0;
      }   
    }
   
   
   
   //If there isn't opened orders watch indicators for a trading signal.
   if (_ExpertOrdersTotal<1) 
   {
     myOrderType=6;
	  
	  //BUY signal.
	  if(TradeMACD && TradeSTOCH)
	  {
	  if(iMACD(0,0,MACDFast,MACDSlow,MACDPeriod,MACDPrice,MODE_MAIN,0)>
	  iMACD(0,0,MACDFast,MACDSlow,MACDPeriod,MACDPrice,MODE_SIGNAL,0) &&
	  iMACD(0,0,MACDFast,MACDSlow,MACDPeriod,MACDPrice,MODE_MAIN,1)>
	  iMACD(0,0,MACDFast,MACDSlow,MACDPeriod,MACDPrice,MODE_SIGNAL,1) &&
	  iMACD(0,0,MACDFast,MACDSlow,MACDPeriod,MACDPrice,MODE_MAIN,2)<
	  iMACD(0,0,MACDFast,MACDSlow,MACDPeriod,MACDPrice,MODE_SIGNAL,2) &&
	  MathAbs(NormalizeDouble(iMACD(0,0,MACDFast,MACDSlow,MACDPeriod,MACDPrice,MODE_MAIN,0),4))>=5*Point &&
	  iStochastic(0,0,KPeriod,DPeriod,Slowing,Method,Price,MODE_MAIN,0)> 20 &&
	  iStochastic(0,0,KPeriod,DPeriod,Slowing,Method,Price,MODE_MAIN,0)< 80 &&
	  iStochastic(0,0,KPeriod,DPeriod,Slowing,Method,Price,MODE_MAIN,0)>
	  iStochastic(0,0,KPeriod,DPeriod,Slowing,Method,Price,MODE_SIGNAL,0))
	  { myOrderType=0; }
	 	  
	  //SELL signal.
	  if(iMACD(0,0,MACDFast,MACDSlow,MACDPeriod,MACDPrice,MODE_MAIN,0)<
	  iMACD(0,0,MACDFast,MACDSlow,MACDPeriod,MACDPrice,MODE_SIGNAL,0) &&
	  iMACD(0,0,MACDFast,MACDSlow,MACDPeriod,MACDPrice,MODE_MAIN,1)<
	  iMACD(0,0,MACDFast,MACDSlow,MACDPeriod,MACDPrice,MODE_SIGNAL,1) &&
	  iMACD(0,0,MACDFast,MACDSlow,MACDPeriod,MACDPrice,MODE_MAIN,2)>
	  iMACD(0,0,MACDFast,MACDSlow,MACDPeriod,MACDPrice,MODE_SIGNAL,2) &&
	  MathAbs(NormalizeDouble(iMACD(0,0,MACDFast,MACDSlow,MACDPeriod,MACDPrice,MODE_MAIN,0),4))>=5*Point &&
	  iStochastic(0,0,KPeriod,DPeriod,Slowing,Method,Price,MODE_MAIN,0)< 80 &&
	  iStochastic(0,0,KPeriod,DPeriod,Slowing,Method,Price,MODE_MAIN,0)> 20 &&
	  iStochastic(0,0,KPeriod,DPeriod,Slowing,Method,Price,MODE_MAIN,0)<
	  iStochastic(0,0,KPeriod,DPeriod,Slowing,Method,Price,MODE_SIGNAL,0))
	  { myOrderType=1; }
	  } //end if both
	  
	  if(TradeMACD && !TradeSTOCH)
	  {
	  if(iMACD(0,0,MACDFast,MACDSlow,MACDPeriod,MACDPrice,MODE_MAIN,0)>
	  iMACD(0,0,MACDFast,MACDSlow,MACDPeriod,MACDPrice,MODE_SIGNAL,0) &&
	  iMACD(0,0,MACDFast,MACDSlow,MACDPeriod,MACDPrice,MODE_MAIN,1)>
	  iMACD(0,0,MACDFast,MACDSlow,MACDPeriod,MACDPrice,MODE_SIGNAL,1) &&
	  iMACD(0,0,MACDFast,MACDSlow,MACDPeriod,MACDPrice,MODE_MAIN,2)<
	  iMACD(0,0,MACDFast,MACDSlow,MACDPeriod,MACDPrice,MODE_SIGNAL,2) &&
	  MathAbs(NormalizeDouble(iMACD(0,0,MACDFast,MACDSlow,MACDPeriod,MACDPrice,MODE_MAIN,0),4))>=5*Point)
	  { myOrderType=0; }
	  
	  if(iMACD(0,0,MACDFast,MACDSlow,MACDPeriod,MACDPrice,MODE_MAIN,0)<
	  iMACD(0,0,MACDFast,MACDSlow,MACDPeriod,MACDPrice,MODE_SIGNAL,0) &&
	  iMACD(0,0,MACDFast,MACDSlow,MACDPeriod,MACDPrice,MODE_MAIN,1)<
	  iMACD(0,0,MACDFast,MACDSlow,MACDPeriod,MACDPrice,MODE_SIGNAL,1) &&
	  iMACD(0,0,MACDFast,MACDSlow,MACDPeriod,MACDPrice,MODE_MAIN,2)>
	  iMACD(0,0,MACDFast,MACDSlow,MACDPeriod,MACDPrice,MODE_SIGNAL,2) &&
	  MathAbs(NormalizeDouble(iMACD(0,0,MACDFast,MACDSlow,MACDPeriod,MACDPrice,MODE_MAIN,0),4))>=5*Point)
	  { myOrderType=1; }
	  } //end if macd only
	  
	  if(!TradeMACD && TradeSTOCH)
	  {
	  if(iStochastic(0,0,KPeriod,DPeriod,Slowing,Method,Price,MODE_MAIN,0)> 20 &&
	  iStochastic(0,0,KPeriod,DPeriod,Slowing,Method,Price,MODE_MAIN,0)< 80 &&
	  iStochastic(0,0,KPeriod,DPeriod,Slowing,Method,Price,MODE_MAIN,0)>
	  iStochastic(0,0,KPeriod,DPeriod,Slowing,Method,Price,MODE_SIGNAL,0))
	  { myOrderType=0; }
	  
	  if(iStochastic(0,0,KPeriod,DPeriod,Slowing,Method,Price,MODE_MAIN,0)< 80 &&
	  iStochastic(0,0,KPeriod,DPeriod,Slowing,Method,Price,MODE_MAIN,0)> 20 &&
	  iStochastic(0,0,KPeriod,DPeriod,Slowing,Method,Price,MODE_MAIN,0)<
	  iStochastic(0,0,KPeriod,DPeriod,Slowing,Method,Price,MODE_SIGNAL,0))
	  { myOrderType=1; }
	  }//end if stoch only
	  
	  
	  //Force enter a new trade.
	  if(ForceOrderType==0 || ForceOrderType==1) { myOrderType=ForceOrderType; }
	  	  
	  //Reverse signal execution. If buy then sell and vice versa.
	  if (ReverseCondition==true)
	  {
	  	  if (myOrderType==0) { myOrderType=1; }
		  else { if (myOrderType==1) { myOrderType=0; } }
	  }
	} //end if _ExpertOrdersTotal<1

	//When opened orders is equal to "OrdenSalto", a jump/fall on the lot size growth
   //in next order will increase/decrease equal to "Salto".
   if(_ExpertOrdersTotal==(OrdenSalto+MaxTradesAux-1))SaltoAux=Salto;
   else SaltoAux = 1;
        
   //Determine lot size in first order only.
   if(mm==true && _ExpertOrdersTotal<1)
   {
      if (MiniAccount==false) {leverage=1000;}
      else { leverage=10000;}
      
      //Determine lot size as % of balance.
      lotsi=NormalizeDouble(AccountBalance()*risk/leverage,2);
   }
   
   //Used when initial lot size is fixed.
   if(mm!=true && _ExpertOrdersTotal<1)
   {
      lotsi=InitialFixedLots;
   }
      
   //Si ya hay ordenes abiertas determina el tamao del lote en funcin de la ltima
   //orden abierta en la serie.
   if(_ExpertOrdersTotal>0)
   {
      //Si se reinici el EA y no se almacen el mayor tamao de lote.
      //Si bien LastLotSize es una variable static que no se pierde al cerrar el EA
      //aseguro el valor de LastLotSize con _ExpertBiggerLot porque de lo contrario
      //no se van a ingresar las ordenes siguientes necesarias de la martingala.
      //Este valor puede ser errneo si LastLotSize > 50. _ExpertBiggerLot ser igual 50.
     if(LastLotSize <= 0 || PreviousOpenOrders <= 0 || myOrderType <= 0)
	  {
	     LastLotSize = _ExpertBiggerLot;
        PreviousOpenOrders = _ExpertOrdersTotal;
        myOrderType = _ExpertOrdersType;
     }
      
     lotsi=NormalizeDouble(LastLotSize*FactorLot*SaltoAux,2);
   }
   
   //Asegura que el tamao del lote sea igual o mayor al InitialFixedLots.
   if(lotsi<=InitialFixedLots) { lotsi=InitialFixedLots; }
   
   //Determina el aumento en la diferencia de pips entre una orden y otra de la martingala.
   PipsStepAux=PipsStep;
   if(_ExpertOrdersTotal>0)
   {
     PipsStepAux=NormalizeDouble(PipsStep*MathPow((1+FactorPips/100),_ExpertOrdersTotal-1),0);  
   }
   
   //Si no hay margen no hace nada.
   if(myOrderType<6 && ContinueOpening == true)
   {
      if(AccountFreeMarginCheck(Symbol(),myOrderType,lotsi)<=0)
      {
          text = "Free Margin :"+DoubleToStr(AccountFreeMargin(),2)+
         " Margen insuficiente para prxima orden." ;
         Print(text);
         info( 4, text, Red );
         return(0);
      }
   }
               
   //Se informa en observaciones de ordenes pendientes el MagicNumber del EA y el nmero de
   //orden de la serie de la martingala.
   text="Magic: "+DoubleToStr(Magic,0)+". Orden: "+(_ExpertOrdersTotal-MaxTradesAux+1)+" de "+MaxTrades;
   
   //Abre ordenes si se dieron las condiciones de los indicadores si hay margen en la cuenta.
   if(ContinueOpening==true)
   {
      int NewOrder;
      switch(myOrderType)
      {
         //BUY
         case 0:
            //Si no hay ordenes abiertas o la ltima pierde PipsStep
            if(_ExpertOrdersTotal<1 ||(_OrderOpenPrice[0]-Ask)>=PipsStepAux*Point)
            {
               if(CloseOnEmergency== true && _ExpertOrdersTotal>=(EmergencyClose+MaxTradesAux-1))
               {
                  CierraTodo();
                  return;
               }
               
               EnterPrice=NormalizeDouble(Ask,Digits);
               if(_ExpertOrdersTotal>0) tp=_OrderOpenPrice[0]+(TakeProfit-PipsStep)*Point;
               else tp = Ask+TakeProfit*Point;
               sl = 0;
         
               myLotAux = NormalizeDouble(MathMod(lotsi,MaxLots),2);
         
               if(myLotAux!=0)
               {
                  //int OrderBuy = OrderSend(Symbol(),OP_BUY,myLotAux,EnterPrice,slippage,sl,tp,text,Magic,0,Blue);
                  //Reservo el valor del tamao del lote anterior completo para cuando tenga que
                  //fraccionar una orden en no ms de MaxLots  50.
                  //Esto tiene que estar dentro del if de "pierde PipsStep". De lo contrario myLotsi
                  //se recalcula con cada pip.
                  NewOrder = AbreOrdenes(myOrderType, PreviousOpenOrders,myLotAux,Blue);
                  
                  //if(OrderBuy>=0) LastLotSize = lotsi; //Si no fall el ingreso de la orden
                  if(NewOrder>0) LastLotSize = lotsi; //Si no fall el ingreso de la orden
               }
               
               if((lotsi/MaxLots)>=1)
		         {
		             cnt2 = NormalizeDouble((lotsi/MaxLots),2)-NormalizeDouble((myLotAux/MaxLots),2);
		             if(cnt2<1) {cnt2=1;}
		             for(cnt=cnt2;cnt>0 ;cnt--)
		             {
		               NewOrder = AbreOrdenes(myOrderType, PreviousOpenOrders,MaxLots,Blue);
		               //int OrderBuyAux = OrderSend(Symbol(),OP_BUY,MaxLots,EnterPrice,slippage,sl,tp,text,Magic,0,Blue);
		               //if(OrderBuyAux>=0) MaxTradesAux++;//Si no fall el ingreso de la orden fraccionada
		               if(NewOrder>0) MaxTradesAux++;//Si no fall el ingreso de la orden fraccionada
		             }
		         }
		         
		         if(NewOrder>0 && _ExpertOrdersTotal>0 && TrailingProfit==true)
               {
                  ChangeTP(tp,PreviousOpenOrders);
               }
		         
		         if(myLotAux==0 && lotsi==MaxLots) { MaxTradesAux--;}
            }
            break;
   
         //SELL
         case 1:
            //Ingresa nuevas ordenes si no hay abiertas o la ltima pierde PipsStep
            if(_ExpertOrdersTotal<1 ||(Bid-_OrderOpenPrice[0])>=PipsStepAux*Point)
            {
               if(CloseOnEmergency== true && _ExpertOrdersTotal>=(EmergencyClose+MaxTradesAux-1))
               {
                  CierraTodo();
                  return;
               }
            
               EnterPrice=NormalizeDouble(Bid,Digits);
               if(_ExpertOrdersTotal>0) tp=_OrderOpenPrice[0]-(TakeProfit-PipsStep)*Point;
               else tp = Bid-TakeProfit*Point;
               sl = 0;
         
               myLotAux = NormalizeDouble(MathMod(lotsi,MaxLots),2);
		    
               if(myLotAux!=0)
               {
                  //int OrderSell = OrderSend(Symbol(),OP_SELL,myLotAux,EnterPrice,slippage,sl,tp,text,Magic,0,Red;
                  NewOrder = AbreOrdenes(myOrderType, PreviousOpenOrders,myLotAux,Red);
                  if(NewOrder>=0) LastLotSize = lotsi; 
               }
       
               if((lotsi/MaxLots)>=1)
		         {
		             cnt2 = NormalizeDouble((lotsi/MaxLots),2)-NormalizeDouble((myLotAux/MaxLots),2);
		             if(cnt2<1) {cnt2=1;}
		             for(cnt=cnt2;cnt>0 ;cnt--)
		             {
                     //int OrderSellAux = OrderSend(Symbol(),OP_SELL,MaxLots,EnterPrice,slippage,sl,tp,text,Magic,0,Red);
                     NewOrder = AbreOrdenes(myOrderType, PreviousOpenOrders,MaxLots,Red);
                     if(NewOrder>=0) MaxTradesAux++; 
                   }
               }
               
               if(NewOrder>=0 && _ExpertOrdersTotal>0 && TrailingProfit==true)
               {
                  ChangeTP(tp,PreviousOpenOrders);
               }
         
               //Esto sirve para evitar un conteo erroneo de la cantidad de ordenes ingresadas
               //cuando el tamao del lote de una orden es exactamente igual a MaxLots  50.
               if(myLotAux==0 && lotsi==MaxLots) { MaxTradesAux--;}
       
            }
            break;
      }//Fin switch myOrderType
      
      //Si lleg el puntero hasta ac Margin>0 & ninguna orden toc TP.
      //Esto hay que asignarlo ni bien se ingresa una orden nueva. Ver caso 04/01/07 EURJPY.
      //En un tic se produjo una entrada buy y al siguiente, dio un salto tan alto que se cerr,
      //pero como el EA actualizaba al inicio de un nuevo tic no tenia actualizado la cantidad
      //de ordenes abiertas.
      AllOrdersInit(Magic);
      PreviousOpenOrders=_ExpertOrdersTotal;
      
    } //Fin ContinueOpening
   
//---- Text showed on top left corner of chart
//
   string text1 = "Magic :"+DoubleToStr(Magic,0)+
   " - Floating P/L: "+DoubleToStr(_ExpertProfitTotal,2);
   
   if(ReverseCondition==true) {text1=text1+" Reverse Signal Enabled";}
   
   string text2 = "Orders Opened: "+DoubleToStr(_ExpertOrdersTotal,0)+
   " - Secuence :"+DoubleToStr((_ExpertOrdersTotal-MaxTradesAux),0)+"/"+MaxTrades+
   " - PreviousOpenOrders: "+DoubleToStr(PreviousOpenOrders,0);
   
   string text3 =  "LastLotSize : "+DoubleToStr(LastLotSize,2)+
   " - NextLotSize :"+DoubleToStr(lotsi,2);
   
   switch(myOrderType)
   {
      case 0:  //BUY
         text3=text3+" - Next Enter :"+DoubleToStr(_OrderOpenPrice[0]-PipsStepAux*Point,Digits);
         break;
      case 1: //SELL
         text3=text3+" - Next Enter :"+DoubleToStr(_OrderOpenPrice[0]+PipsStepAux*Point,Digits);
         break;
      default:  //No defined
         text3=text3+" No Type Order";
         break;
   }
   
   if(StopTrading==true)
   {
      string text4 = "EA SE DETENDRA CUANDO CIERRE MARTINGALA ABIERTA";
   }
   else text4="ForceOrderType :"+DoubleToStr(ForceOrderType,0);
   
   if(UpdateVar) {text4 = text4+"- UpdateVar Enabled";}
   
   //Para agregar martingale margin tengo que modificar AllOrdersControl.
   if(ContinueOpening==true)
   {
      string text5 = "ContinueOpening - Account Margin :"+DoubleToStr(AccountFreeMargin(),2);
   }
   else text5 = "Disabled to open new orders";
   
   if(_ExpertOrdersTotal>0)
   {
      if(myOrderType<6 && lotsi!=0)
      {
         if(AccountFreeMarginCheck(Symbol(),myOrderType,lotsi)<=0)
         {
            text5 = text5+ " Margen insuficiente para prxima orden." ;
         }
      }
   }
   
   info( 0, text1, White, 8 );
	info( 1, text2, White );
	info( 2, text3, White );
	info( 3, text4, White );
	info( 4, text5, White );  


//----
   return(0);
  }
//----------------------------  
  

//+------------------------------------------------+
//| Manage martingale closing                      |
//+------------------------------------------------+
void CierraTodo()
{
//----
   for(int h=OrdersTotal() ; h>=0; h--)
	{
	  OrderSelect(h, SELECT_BY_POS, MODE_TRADES);
	  if (OrderSymbol()==Symbol() && OrderMagicNumber() == Magic) 
	  {
	     for(int i = 1 ; i <= NumberOfTries; i++)
	     {
	        bool TicketClosed = OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(OrderClosePrice(),Digits),slippage,Yellow);
	        
	        if(!TicketClosed)
   	     {
   	        error = GetLastError(); 
		        Print("Error :",error," cerrando orden: ",OrderTicket(),
		        ". Reintento :",i,"/",NumberOfTries);
		        Sleep(5000); //5 segundos
		     }
		     else   break;
	     } //end for i
	        
	     if(!TicketClosed)
   	  {
   	     int error = GetLastError();
		     Print("No se pudo cerrar orden: ",OrderTicket()," Error: ",error," ",ErrorDescription(error));
		  }
	  }
	} //end for h
//----
   return;
} 


//+-----------------------------------------------------------------------------------------+
// Modifies take profit of opened orders to ensure exact and simultaneous close of all the
// martingale. It also avoids problems on internet connection, because take profit is placed
// on broker server.
//+-----------------------------------------------------------------------------------------+
void ChangeTP(double TP, int OrderOnThisMartingale)
{
    
   for(int h=0; h<OrdersTotal()-1; h++)
   {

      OrderSelect(h, SELECT_BY_POS, MODE_TRADES);
      
      if (OrderSymbol()==Symbol() && OrderMagicNumber() == Magic) 
	   {
	        //This avoid change TP on the last/s martingale's order/s when its lot size
	        //is bigger than MaxLotSize.    
	        if(OrderOnThisMartingale <= 0)
	        { break; }
	    
	        OrderOnThisMartingale--;
	           
	        for(int i = 1 ; i <= NumberOfTries; i++)
	        {
	           bool TicketModify = OrderModify(OrderTicket(),0,0,TP,0,Lime);
	        
	           if(!TicketModify)
   	        {
   	           error = GetLastError(); 
		           Print("Error :",error," modificando orden: ",OrderTicket(),
		           ". Reintento :",i,"/",NumberOfTries);
		           Sleep(5000); //5 segundos
		        }
		        else   break;
	        } //end for i
	        
	        if(!TicketModify) { Print("No se pudo modificar orden :",OrderTicket()); }
	    }
      
   
   } //end for h


//----
   return;
}


//+--------------------------------------------------------+
//  Open new orders and mange errors
//+--------------------------------------------------------+  
int AbreOrdenes(int OrdenTipo, int OrderOnThisMartingale, double Lote, color Color )
{
//----
   
	for(int i = 1 ; i <= NumberOfTries; i++)
	{
	   RefreshRates();
	   int TicketOpened = OrderSend(Symbol(),OrdenTipo,Lote,EnterPrice,slippage,sl,tp,text,Magic,0,Color);
	     
	   if(TicketOpened<1)
        {         
		    error = GetLastError(); 
		    Print("Error :",error," opening orden #",OrderOnThisMartingale,"/",MaxTrades,
		    ". Reintento :",i,"/",NumberOfTries);		  		   
		    if (error == ERR_TRADE_CONTEXT_BUSY) if (IsTradeContextBusy()) Sleep(1000*1);
		    if ((error == ERR_SERVER_BUSY) || (ERR_INVALID_TRADE_VOLUME) || (error == ERR_MARKET_CLOSED)){ Sleep(1000*300); break;}      
          if ((error == ERR_TOO_FREQUENT_REQUESTS) || (error == ERR_TOO_MANY_REQUESTS)) Sleep(1000*100);      
          if ((error == ERR_ORDER_LOCKED) || (error == ERR_LONG_POSITIONS_ONLY_ALLOWED) || (error == ERR_TRADE_TOO_MANY_ORDERS)) break;                    
          if ((error != ERR_PRICE_CHANGED) && (error != ERR_REQUOTE)) Sleep(1000*7.7);             
		    Sleep(2000); //2 segundos		    
	     }
		else
		{
		   Print("Ticket Opened by EA :",DoubleToStr(TicketOpened,0));
		   break;
		}
	 } //end for i
	        
	 if(TicketOpened<1)
    {
       int error = GetLastError();
	    Print("No se pudo abrir orden: ",DoubleToStr(myLotAux,2),
	    " lotes de",Symbol()," a EnterPrice, y TP: ",tp);
	    
	    Print("Error :",error," - ",ErrorDescription(error));
	 }


//----
   return(TicketOpened);
} 




//+------------------------------------------------------------------+